//  Sage Android Client.
//  Connect to a Sage server, remotely execute commands and display results.
//
//  Copyright (C) 2010, Harald Schilly <harald.schilly@gmail.com>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

package org.sagemath.android;

import org.sagemath.android.Calculation;

interface CalculationListener {
  /**
   * Callback from background service to the actual App. 
   * 
   * @return if <code>true</code> the calculation was consumed and we do not need
   * to ask more listeners to handle the result.
   */
  boolean handleCalculationResult(in Calculation c);
}

